## magics++ 2.30.0

=== CMakeLists.txt ===
############################################################################################
# cmake options:
#
#       -DCMAKE_BUILD_TYPE=Debug|RelWithDebInfo|Release|Production
#
#       -DCMAKE_MODULE_PATH=/path/to/ecbuild/cmake
#
#       -DCMAKE_C_COMPILER=gcc
#       -DCMAKE_C_COMPILER=g++
#
#       -DCMAKE_PREFIX_PATH=/path/to/jasper:/path/to/any/package/out/of/place
#       -DBUILD_SHARED_LIBS=OFF

# TODO:
#  * fix python module generation Magics.py to __init__.py
#  * cpack ecbuild/cmake macros into tar.gz
#  * unit tests check that certain files are produced and not empty
#  * pkg-config needed for metview

# Missing dependencies:
#   * ghostscript ( is it really needed? -- to confirm )

cmake_minimum_required( VERSION 2.8.11 FATAL_ERROR )

project( magics CXX )

# make sure that the header files are installed into include/magics
# note that this needs to be done before ecbuild_declare_project()
# to ensure that the ecbuild header files are also put there
# note also that we need to CACHE this so that ecbuild_declare_project() does not overwrite it
set(MAGICS_INSTALL_INCLUDE_DIR include/magics CACHE PATH "Magics installation directory for header files")
set(INSTALL_INCLUDE_DIR include/magics CACHE PATH "Magics installation directory for header files")

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")

include( ecbuild_system NO_POLICY_SCOPE )

ecbuild_requires_macro_version( 1.9 )

###############################################################################
# some variables of this project

ecbuild_add_option( FEATURE ECCODES DESCRIPTION "" DEFAULT ON )

if( HAVE_ECCODES )
  ecbuild_use_package( PROJECT eccodes VERSION 0.14 REQUIRED )
  set( GRIB_API_INCLUDE_DIRS ${ECCODES_INCLUDE_DIRS} )
  set( GRIB_API_LIBRARIES    ${ECCODES_LIBRARIES} )
  set( GRIB_API_DEFINITIONS  ${ECCODES_DEFINITIONS} )
  set( grib_api_BASE_DIR     ${eccodes_BASE_DIR} )
  set( grib_handling_pkg eccodes )
else()
  ecbuild_use_package(PROJECT grib_api VERSION 1.14.6 REQUIRED)
  set( grib_handling_pkg grib_api )
endif()


# grib_api is required for now
set( HAVE_GRIB 1 )

ecbuild_add_option( FEATURE BUFR
                    DEFAULT ON
                    DESCRIPTION "BUFR support"
                    REQUIRED_PACKAGES "PROJECT libemos VERSION 4.0.5" )

ecbuild_add_option( FEATURE ODB
                    DEFAULT ON
                    DESCRIPTION "ODB support"
                    REQUIRED_PACKAGES "PROJECT odb_api VERSION 0.10.2")
					#	"PROJECT eckit   VERSION 0.9.0" )

ecbuild_add_option( FEATURE CAIRO
                    DEFAULT ON
                    DESCRIPTION "cairo support[png/jpeg]"
                    REQUIRED_PACKAGES PangoCairo )

ecbuild_add_option( FEATURE GEOTIFF
                    DEFAULT OFF
                    DESCRIPTION "geotiff support [implies cairo]"
                    CONDITION HAVE_CAIRO
                    REQUIRED_PACKAGES GeoTIFF )

ecbuild_add_option( FEATURE NETCDF
                    DEFAULT ON
                    DESCRIPTION "enable netcdf support"
                    REQUIRED_PACKAGES "NetCDF 4 COMPONENTS C CXX" )

ecbuild_add_option( FEATURE SPOT
                    DEFAULT OFF
                    DESCRIPTION "enable spot support"
                    REQUIRED_PACKAGES "PROJECT spot" )

ecbuild_add_option( FEATURE PYTHON
                    DEFAULT ON
                    DESCRIPTION "enable python interface"
                    REQUIRED_PACKAGES "Python NO_LIBS" SWIG NumPy )

ecbuild_add_option( FEATURE FORTRAN
                    DEFAULT ON
                    DESCRIPTION "enable Fortran interface" )

if( HAVE_FORTRAN )
	ecbuild_enable_fortran( REQUIRED )
endif()

ecbuild_add_option( FEATURE METVIEW
                    DEFAULT OFF
                    DESCRIPTION "enable Metview interface" )

ecbuild_add_option( FEATURE METVIEW_NO_QT
                    DEFAULT OFF
                    DESCRIPTION "enable Metview interface without Qt" )

ecbuild_add_option( FEATURE QT5
                    DEFAULT OFF
                    DESCRIPTION "use Qt5 instead of version 4" )

ecbuild_add_option( FEATURE PNG
                    DESCRIPTION "support for PNG decoding/encoding"
                    DEFAULT ON
                    REQUIRED_PACKAGES PNG
)

if( HAVE_PNG )
    add_definitions( ${PNG_DEFINITIONS} )
endif()

option( BUILD_SHARED_LIBS  "Set to BOTH to build static library in addition to shared"  ON )
option( ENABLE_REGRESSION        "Internal use only: enable regression test"  OFF  )
option( ENABLE_REGRESSION_UPLOAD "Internal use only : enable upload of reference image"  OFF  )

set( MAGICS_NAME          "Magics" )
set( MAGICS_EXCEPTION     "ON" )
set( MAGICS_SITE          "ecmwf" )
set( MAGICS_INSTALL_PATH  ${CMAKE_INSTALL_PREFIX} )

set( MAGICS_REFERENCE_VERSIONS            "2.29.6" )
set( MAGICS_HTML_ROOT        "${CMAKE_BINARY_DIR}/regression/html")
file(MAKE_DIRECTORY ${MAGICS_HTML_ROOT} )

set( MAG_PYTHON_PATH ${CMAKE_CURRENT_BINARY_DIR}/python )

###############################################################################
# projects

# ecbuild_use_package( PROJECT eckit VERSION 0.3 REQUIRED )

#ecbuild_add_cxx_flags("-gdwarf-2")
ecbuild_add_c_flags("-std=c99")

### Metview and Qt

if(HAVE_METVIEW AND HAVE_METVIEW_NO_QT)
    message(FATAL_ERROR "Do not set both HAVE_METVIEW and HAVE_METVIEW_NO_QT - only set one. You may have to remove your CMakeCache.txt to clear these settings.")
endif()

set( qt no )
set( metview no )

if( HAVE_METVIEW_NO_QT )
	set( metview yes )
	unset(MAGICS_ONLY)
endif()

if( HAVE_METVIEW )
    set ( metview yes)
    message(STATUS "TESTING for Metview ...")
    unset(MAGICS_ONLY)

    if( HAVE_QT5 )
      find_package(Qt5Widgets REQUIRED)
      if( Qt5Widgets_FOUND )
          message(STATUS "Qt5 was found ... ${Qt5Widgets_VERSION_STRING}")
          include_directories(${Qt5Widgets_INCLUDE_DIRS})
          set( MAGICS_QT 1)
          set( MAGICS_QT5 1)
          set( qt yes)
          add_definitions( -DMAGICS_QT5 )
      else()
          message(FATAL_ERROR "Qt5 was NOT found ...")
      endif()
    else()
    find_package(Qt4 4.4.3 REQUIRED QtCore QtGui QtXml )
    if( QT_FOUND )
		  include( ${QT_USE_FILE} )
		  set( MAGICS_QT 1)
		  set( qt yes)
    endif()
    endif()
endif()

ecbuild_declare_project()

###############################################################################
# find extra packages

set( CMAKE_THREAD_PREFER_PTHREAD 1 )
find_package( Threads ) 

# set(Boost_USE_STATIC_LIBS        ON)
# set(Boost_NO_SYSTEM_PATHS        ON)
# set(Boost_USE_MULTITHREADED      ON)
#ecbuild_add_extra_search_paths( boost )

find_package( Boost 1.49.0 REQUIRED)
find_package( Proj4 REQUIRED )
find_package( EXPAT REQUIRED )

###############################################################################
# contents

set( MAGICS_TPLS grib_api spot EXPAT NetCDF PNG Proj4 libemos )

set( MAGICS_INCLUDE_DIRS 
     ${CMAKE_CURRENT_SOURCE_DIR}/src 
     ${CMAKE_BINARY_SOURCE_DIR}/src 
     ${CMAKE_CURRENT_SOURCE_DIR}/src/common 
     ${CMAKE_CURRENT_BINARY_DIR}/src/params 
     ${CMAKE_CURRENT_BINARY_DIR}/src 
     ${CMAKE_CURRENT_SOURCE_DIR}/src/common  
     ${CMAKE_CURRENT_SOURCE_DIR}/src/basic
     ${CMAKE_CURRENT_SOURCE_DIR}/src/web
     ${CMAKE_CURRENT_SOURCE_DIR}/src/visualisers
     ${CMAKE_CURRENT_SOURCE_DIR}/src/drivers
     ${CMAKE_CURRENT_SOURCE_DIR}/src/drivers/MgQ
     ${CMAKE_CURRENT_SOURCE_DIR}/src/eckit_readers
     ${CMAKE_CURRENT_SOURCE_DIR}/src/decoders
     ${CMAKE_CURRENT_SOURCE_DIR}/src/terralib
     ${CMAKE_CURRENT_SOURCE_DIR}/src/terralib/kernel
     ${CMAKE_CURRENT_SOURCE_DIR}/src/libMagWrapper
     ${Boost_INCLUDE_DIRS} )

if( HAVE_CAIRO )
  list( APPEND MAGICS_TPLS PangoCairo )
  list( APPEND MAGICS_INCLUDE_DIRS ${PANGOCAIRO_INCLUDE_DIRS} )
endif()

if( HAVE_ODB )
  list( APPEND MAGICS_TPLS odb_api )
  list( APPEND MAGICS_INCLUDE_DIRS
        ${CMAKE_CURRENT_SOURCE_DIR}/src/oda
        ${ODB_API_INCLUDE_DIRS}
		${ECKIT_INCLUDE_DIRS} )
endif()

set( MAGICS_LIBRARIES    MagPlus )

foreach( _tpl ${MAGICS_TPLS} )
    string( TOUPPER ${_tpl} TPL )
    if( NOT ${TPL} STREQUAL "LIBEMOS" ) # don't add libemos definitions
    list( APPEND MAGICS_EXTRA_DEFINITIONS   ${${TPL}_DEFINITIONS}  )
    endif()
    list( APPEND MAGICS_EXTRA_INCLUDE_DIRS  ${${TPL}_INCLUDE_DIRS} )
    list( APPEND MAGICS_EXTRA_LIBRARIES     ${${TPL}_LIBRARIES} )
endforeach()

if( HAVE_BUFR )
	list( APPEND MAGICS_EXTRA_DEFINITIONS   fortfloat=double fortint=int )
    ecbuild_find_fortranlibs()
	list( APPEND MAGICS_EXTRA_LIBRARIES ${FORTRAN_LIBRARIES} )
endif()
if( WITH_QT_DEBUG )
	list( APPEND MAGICS_EXTRA_DEFINITIONS QT_NO_DEBUG_OUTPUT )
endif()

if( MAGICS_QT )
  if( MAGICS_QT5 )
    list( APPEND MAGICS_EXTRA_INCLUDE_DIRS  ${Qt5Widgets_INCLUDE_DIR} )
    list( APPEND MAGICS_EXTRA_LIBRARIES     ${Qt5Widgets_LIBRARIES} )
  else()
	list( APPEND MAGICS_EXTRA_INCLUDE_DIRS  ${QT_INCLUDE_DIR} )
	list( APPEND MAGICS_EXTRA_LIBRARIES     ${QT_LIBRARIES} )
endif()
endif()

if( HAVE_GEOTIFF )
	list( APPEND MAGICS_EXTRA_INCLUDE_DIRS  ${GEOTIFF_INCLUDE_DIR} )
	list( APPEND MAGICS_EXTRA_LIBRARIES  ${GEOTIFF_LIBRARY} )
  list( APPEND MAGICS_EXTRA_DEFINITIONS HAVE_GEOTIFF )
endif()

list( APPEND MAGICS_EXTRA_LIBRARIES     ${CMAKE_THREAD_LIBS_INIT} )

ecbuild_debug("MAGICS_EXTRA_DEFINITIONS  => ${MAGICS_EXTRA_DEFINITIONS}")
ecbuild_debug("MAGICS_EXTRA_INCLUDE_DIRS => ${MAGICS_EXTRA_INCLUDE_DIRS}")
ecbuild_debug("MAGICS_EXTRA_LIBRARIES    => ${MAGICS_EXTRA_LIBRARIES}")

# set_directory_properties( PROPERTIES COMPILE_DEFINITIONS "${ECKIT_DEFINITIONS}" )
get_directory_property( MAGICS_DEFINITIONS COMPILE_DEFINITIONS )

include_directories( ${MAGICS_INCLUDE_DIRS} ${MAGICS_EXTRA_INCLUDE_DIRS} )

# scripts
add_subdirectory( tools )

# source files
add_subdirectory( src )

# shared files
add_subdirectory( share )

# python interface 
add_subdirectory( python )

# apps directory
add_subdirectory( apps )

# Test directory
add_subdirectory( test )
if( ENABLE_REGRESSION )
    add_subdirectory( regression )
endif()

# Directories not need in the distribution tar ball!
ecbuild_add_resources( TARGET old_src DONT_PACK_DIRS src/MvObs src/libTable src/xml src/terralib/functions)
ecbuild_add_resources( TARGET bamboo DONT_PACK_DIRS bamboo)
ecbuild_add_resources( TARGET old_ressources 
		DONT_PACK_DIRS tools/versioncmp 
		tools/regression 
		regression
		docs
		toolsjs
		test/old
		tools/xml 
		tools/use_scripts
		tools/versioncmp_folders)

ecbuild_add_resources( TARGET internal 
		DONT_PACK configure.lxab
		configure.local
		configure.ecgb
		configure.ecmwf
)

############################################################################################
# finalize

set( MAGICS_DESCRIPTION "Multi-platform meteorological graphics library" )
set( MAGICS_URL "https://software.ecmwf.int/wiki/display/MAGP/Magics" )
ecbuild_pkgconfig()

ecbuild_install_project( NAME Magics )

ecbuild_print_summary()

=== debian/changelog ===
magics++ (2.30.0-4) unstable; urgency=medium

  * Update python3 patch. Closes: #847193
  * Drop grib_api from CMAKE_PREFIX_PATH in debian/rules

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 07 Dec 2016 15:13:17 +0000

magics++ (2.30.0-3) unstable; urgency=medium

  * Ensure dep. on libopenjp2-7-dev present. Closes: #846920

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 05 Dec 2016 06:42:10 +0000

magics++ (2.30.0-2) unstable; urgency=medium

  * libemos-bin node a build-dependency. Closes: #846505

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 02 Dec 2016 06:37:27 +0000

magics++ (2.30.0-1) unstable; urgency=medium

  * New upstream release
  * Build-dep against eccodes not grib-api
  * Split dh_fixperms-arch for FTBFS on dpkg-buildpackage -A.
    Closes: #846092
  * debian/rules: now need to specify geotiff location

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 28 Nov 2016 15:18:58 +0000

=== debian/control ===
Source: magics++
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper  (>= 10) , dh-buildinfo, gfortran, cmake, chrpath,
 dh-python,  swig,
 python-all-dev, python-numpy, 
 python3-all-dev, python3-numpy,
 libhdf5-serial-dev | libhdf5-dev, libnetcdf-dev, libnetcdf-cxx-legacy-dev,
 libgl1-mesa-dev, libgd-dev, 
 libemos-dev (>=  2:4.3.9), libgeotiff-dev,
 libeccodes-dev | libgrib-api-dev (>= 1.14.5-2), 
 libeccodes-tools | libgrib-api-tools, 
 libemos-bin, libopenjp2-7-dev,
 libaec-dev,
 libterralib-dev, 
 libcairo2-dev, libpango1.0-dev,
 ttf-dejavu-core, libxml-parser-perl, 
 ghostscript, zlib1g-dev, libboost-dev, libproj-dev, 
 qtbase5-dev-tools, qtbase5-dev, qt5-qmake
Standards-Version: 3.9.8
Homepage: https://software.ecmwf.int/wiki/display/MAGP/Magics
Vcs-Git: git://anonscm.debian.org/debian-science/packages/magics.git

Package: libmagplus3v5
Section: libs
Architecture: any
Multi-Arch: same
Depends: libmagics++-data,${misc:Depends}, ${shlibs:Depends}, ttf-dejavu-core, ttf-dejavu-extra, ghostscript
Description: ECMWF meteorological plotting software library
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 Besides its programming interfaces (Fortran and C), Magics++ offers MagML,
 a plot description language based on XML aimed at automatic web production.
 .
 The library supports the plotting of contours, wind fields, observations,
 satellite images, symbols, text, axis and graphs (including boxplots).
 .
 Data fields to be plotted may be presented in various formats,
 for instance GRIB 1 and 2 code data, Gaussian grid, regularly spaced grid
 and fitted data. Input data can also be in BUFR and NetCDF format
 or retrieved from an ODB database.
 .
 The produced meteorological plots can be saved in various formats,
 such as PostScript, EPS, PDF, GIF, PNG, SVG and KML.

Package: libmagics++-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libmagplus3v5 ( = ${binary:Version} ), ${misc:Depends}, ${python:Depends}, libterralib-dev, magics++
Recommends: pkg-config
Description: Development files for ECMWF  plotting software MAGICS++
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 Besides its programming interfaces (Fortran and C), Magics++ offers MagML,
 a plot description language based on XML aimed at automatic web production.
 .
 This package includes the header files and static libraries needed to build 
 against libmagics++.

Package: magics++
Architecture: any
Multi-Arch: foreign
Depends: libmagplus3v5 ( = ${binary:Version} ),
 ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}
Description: Executables for the magics++ library
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 Besides its programming interfaces (Fortran and C), Magics++ offers MagML,
 a plot description language based on XML aimed at automatic web production.
 .
 This package contains the MagcML binary that may be used with magics++.

Package: python-magics++
Section: python
Architecture: any
Depends:  libmagplus3v5 ( = ${binary:Version} ), ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}, python, python-simplejson
Description: python support for Magics++
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 .
 This package provides python support for the magics++ library.

Package: python3-magics++
Section: python
Architecture: any
Depends:  libmagplus3v5 ( = ${binary:Version} ), ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends}, python3-simplejson
Description: Python3 support for Magics++
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 .
 This package provides Python3 support for the magics++ library.

Package: libmagics++-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Data files needed for magics++ library
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 .
 This package contains data expected by the magics++ library.


Package: libmagics++-metview-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libmagplus3v5 ( = ${binary:Version} )
Description: Libraries needed for building MetView
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 .
 This package includes the header files and static libraries needed to build
 metview against magics++.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

# To enable all, uncomment following line
# DEB_BUILD_MAINT_OPTIONS:= hardening=+all,-pie
CXXFLAGS:= -fPIC $(shell dpkg-buildflags --get CXXFLAGS) # -std=c++14
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Set for build reproducibility
LC_ALL=C
export LC_ALL

export QT_SELECT=5

LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)
AUTOGENERATED:= libmagplus3v5.links libmagics++-dev.links libmagplus3v5.install
# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

%:
	dh $@ --parallel --with python2,python3 --with-buildsystem=cmake

# To fix cmake output change these
OLD_GF_PATH=$(shell gfortran -print-search-dirs | grep install | cut -f2 -d' '  )libgfortran.so
NEW_GF_PATH:=$(LIBDIR)/libgfortran.so.3

# -DCMAKE_PREFIX_PATH=${LIBDIR}/cmake/grib_api \

export extra_flags +=  \
	-DBUILD_SITE=debian \
	-DENABLE_LIBGD=1 \
	-DHAVE_BOOST=1 \
	-DHAVE_DLFCN_H=1 \
	-DHAVE_INTTYPES_H=1 \
	-DHAVE_LIBEXPAT=1 \
	-DHAVE_LIBPROJ=1 \
	-DHAVE_LIBPTHREAD=1 \
	-DHAVE_LIBZ=1 \
	-DHAVE_MEMORY_H=1 \
	-DHAVE_STDINT_H=1 \
	-DHAVE_STDLIB_H=1 \
	-DHAVE_STRINGS_H=1 \
	-DHAVE_STRING_H=1 \
	-DHAVE_SYS_STAT_H=1 \
	-DHAVE_STS_TYPES_H=1 \
	-DHAVE_UNISTD_H=1 \
	-DMAGICS_ALLHEADERS=1 \
	-DMAGICS_GRIB=1 \
	-DMAGICS_JSON=1 \
	-DMAGICS_METVIEW=1 \
	-DMAGICS_GIF=1 \
	-DMAGICS_GIF_ANIMATED=1 \
	-DMAGICS_TIFF=1 \
	-DMAGICS_TTF=1 \
	-DMAGICS_TTF_PATH="share/magics/ttf/" \
	-DMAGICS_SITE="debian" \
	-DMAGICS_PYTHON=1 \
	-DMAGICS_THREADS=1 \
	-DDISABLE_OS_CHECK=ON \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DBUILD_DOCUMENTATION=ON \
	-DENABLE_FORTRAN=ON \
	-DENABLE_LARGE_FILE_SUPPORT=ON \
	-DENABLE_PYTHON=ON \
	-DBUILD_EXAMPLES=ON \
	-DBUILD_SHARED_LIBS=ON \
	-DENABLE_TESTS=ON \
	-DENABLE_GEOTIFF=ON \
	-DGEOTIFF_INCLUDE_DIR=/usr/include/geotiff \
	-DENABLE_RPATHS=OFF \
	-DENABLE_CAIRO=ON \
	-DENABLE_BUFR=ON \
	-DENABLE_GRIB=ON \
	-DENABLE_METVIEW=ON \
	-DENABLE_QT5=ON \
	-DENABLE_NETCDF=ON \
	-DCMAKE_CXX_FLAGS='$(CXXFLAGS) -I/usr/include/terralib -I/usr/include/terralib/kernel' \
	-DMAGICS_EXTRA_LIBRARIES='-lterralib -lgd -lemosR64' 

export LD_LIBRARY_PATH:=$(CURDIR)/debian/tmp/usr/lib:$(LD_LIBRARY_PATH)

override_dh_auto_clean:
	rm -rf debian/build-py*
	rm -f bin/magjsonx  bin/magmlx  bin/metgramx
	find . -type l -delete
	rm -f src/params/*.h src/decoders/*Attributes.h
	rm -rf share/magics/ttf src/terralib debian/build
	rm -f $(patsubst %, debian/%, ${AUTOGENERATED})

override_dh_auto_configure:
	# link for font for tesing.
	mkdir -p share/fonts/truetype/ttf-dejavu/
	ln -sf /usr/share/fonts/truetype/ttf-dejavu/DejaVuSans.ttf share/fonts/truetype/ttf-dejavu/
	# Link terralib
	[ -e src/terralib ] || ln -sf  /usr/include/terralib src/terralib
	for f in ${AUTOGENERATED} ; do \
                sed -e 's%@ARCH@%${DEB_HOST_MULTIARCH}%g' < debian/$$f.in  > debian/$$f ; \
                done
	dh_auto_configure --builddirectory=debian/build-py3 -- \
		-DPYTHON_EXECUTABLE=/usr/bin/python3 \
	       	$(extra_flags) 
	dh_auto_configure --builddirectory=debian/build-py2 -- \
		-DPYTHON_EXECUTABLE=/usr/bin/python \
	       	$(extra_flags) 
	(cd python/Magics && ln -s $(CURDIR)/debian/build-py3/python/Magics/Magics.i )

override_dh_auto_build:
	dh_auto_build  --builddirectory=debian/build-py2
	dh_auto_build  --builddirectory=debian/build-py3

override_dh_auto_test check:
	# echo "Tests disabled; see README-testfailures.txt for details"
	# (ulimit -s 8192; export PYTHONPATH=$(CURDIR)/debian/build-py2/python/Magics ; \
	#	export MAGPLUS_HOME=$(CURDIR) ; $(MAKE) -C debian/build-py2  check )
	#(ulimit -s 8192; export PYTHONPATH=$(CURDIR)/debian/build-py3/python/Magics ; \
	#	export MAGPLUS_HOME=$(CURDIR) ; $(MAKE) -C debian/build-py3  check )

override_dh_auto_install:
	(cd  debian/build-py2/python && python2 ./setup.py install --prefix=$(CURDIR)/debian/tmp/usr )
	(cd  debian/build-py3/python && python3 ./setup.py install --prefix=$(CURDIR)/debian/tmp/usr )
	dh_auto_install --builddirectory=debian/build-py3
	# Move lib stuff
	mkdir -p debian/tmp/$(LIBDIR)
	cp -a debian/tmp/usr/lib/*.a debian/tmp/usr/lib/pkgconfig debian/tmp/$(LIBDIR)
	cp debian/tmp/usr/lib/libMagPlus.so debian/tmp/$(LIBDIR)/libMagPlus.so.3.0.0
	# Fixup the cmake files.
	mkdir -p debian/tmp/$(LIBDIR)/cmake/magics
	cp -a debian/tmp/usr/share/magics/cmake/* debian/tmp/$(LIBDIR)/cmake/magics
	sed -e 's%$${_IMPORT_PREFIX}/lib%$(LIBDIR)%' \
		< debian/tmp/usr/share/magics/cmake/magics-targets-none.cmake \
	| sed -e 's%$${_IMPORT_PREFIX}/bin%/usr/bin%' \
	| sed -e 's%$(OLD_GF_PATH)%$(NEW_GF_PATH)%'   \
		> debian/tmp/$(LIBDIR)/cmake/magics/magics-targets-none.cmake
	rm -r debian/tmp/usr/share/magics/cmake
	dh_python2 /usr/lib/python2.7/site-packages/Magics
	dh_python3 /usr/lib/python3*/site-packages/Magics
	dh_numpy -p python-magics++
	dh_numpy3 -p python3-magics++
	-find debian/tmp/usr/bin -type f  -exec chrpath -d {} \;
	-find debian/tmp debian/libmagplus3v5   -name '*.so*' -exec chrpath -d {} \;

override_dh_fixperms-arch:
	dh_fixperms
	find debian/tmp debian/python*-magics++   -name '*.so*' -exec chrpath -d {} \;

## magics++ 2.34.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -28,29 +28,37 @@
 # note that this needs to be done before ecbuild_declare_project()
 # to ensure that the ecbuild header files are also put there
 # note also that we need to CACHE this so that ecbuild_declare_project() does not overwrite it
-set(MAGICS_INSTALL_INCLUDE_DIR include/magics CACHE PATH "Magics installation directory for header files")
 set(INSTALL_INCLUDE_DIR include/magics CACHE PATH "Magics installation directory for header files")
 
 set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")
 
 include( ecbuild_system NO_POLICY_SCOPE )
 
-ecbuild_requires_macro_version( 1.9 )
+ecbuild_requires_macro_version( 2.6 )
 
 ###############################################################################
 # some variables of this project
 
 ecbuild_add_option( FEATURE ECCODES DESCRIPTION "" DEFAULT ON )
 
-if( HAVE_ECCODES )
-  ecbuild_use_package( PROJECT eccodes VERSION 0.14 REQUIRED )
+set(ECCODES_FAIL_MSG "Note: grib_api can be used instead (select with -DENABLE_ECCODES=OFF), "
+                      "but we strongly advise you to upgrade to ecCodes. "
+                      "See https://software.ecmwf.int/wiki/display/ECC/ecCodes+Home\n"
+                      )
+
+ecbuild_add_option( FEATURE ECCODES DESCRIPTION "Use eccodes instead of grib_api"
+                    REQUIRED_PACKAGES "PROJECT eccodes VERSION 0.14 REQUIRED FAILURE_MSG ECCODES_FAIL_MSG"
+                    DEFAULT ON )
+
+if( HAVE_ECCODES)
   set( GRIB_API_INCLUDE_DIRS ${ECCODES_INCLUDE_DIRS} )
   set( GRIB_API_LIBRARIES    ${ECCODES_LIBRARIES} )
   set( GRIB_API_DEFINITIONS  ${ECCODES_DEFINITIONS} )
   set( grib_api_BASE_DIR     ${eccodes_BASE_DIR} )
   set( grib_handling_pkg eccodes )
 else()
-  ecbuild_use_package(PROJECT grib_api VERSION 1.14.6 REQUIRED)
+  ecbuild_use_package( PROJECT grib_api VERSION 1.14.3 REQUIRED
+                       FAILURE_MSG "ecCodes can be used instead (enable with -DENABLE_ECCODES=ON)" )
   set( grib_handling_pkg grib_api )
 endif()
 
@@ -134,7 +142,7 @@
 set( MAGICS_SITE          "ecmwf" )
 set( MAGICS_INSTALL_PATH  ${CMAKE_INSTALL_PREFIX} )
 
-set( MAGICS_REFERENCE_VERSIONS            "2.29.6" )
+set( MAGICS_REFERENCE_VERSIONS            "2.32.0" )
 set( MAGICS_HTML_ROOT        "${CMAKE_BINARY_DIR}/regression/html")
 file(MAKE_DIRECTORY ${MAGICS_HTML_ROOT} )
 
@@ -149,9 +157,10 @@
 ecbuild_add_c_flags("-std=c99")
 
 ### Metview and Qt
+ecbuild_info("TESTING for Metview and Qt ...")
 
 if(HAVE_METVIEW AND HAVE_METVIEW_NO_QT)
-    message(FATAL_ERROR "Do not set both HAVE_METVIEW and HAVE_METVIEW_NO_QT - only set one. You may have to remove your CMakeCache.txt to clear these settings.")
+    ecbuild_critical("Do not set both HAVE_METVIEW and HAVE_METVIEW_NO_QT - only set one. You may have to remove your CMakeCache.txt to clear these settings.")
 endif()
 
 set( qt no )
@@ -164,20 +173,20 @@
 
 if( HAVE_METVIEW )
     set ( metview yes)
-    message(STATUS "TESTING for Metview ...")
+    ecbuild_info("TESTING for Metview ...")
     unset(MAGICS_ONLY)
 
     if( HAVE_QT5 )
       find_package(Qt5Widgets REQUIRED)
       if( Qt5Widgets_FOUND )
-          message(STATUS "Qt5 was found ... ${Qt5Widgets_VERSION_STRING}")
+          ecbuild_info("Qt5 was found ... ${Qt5Widgets_VERSION_STRING}")
           include_directories(${Qt5Widgets_INCLUDE_DIRS})
           set( MAGICS_QT 1)
           set( MAGICS_QT5 1)
           set( qt yes)
           add_definitions( -DMAGICS_QT5 )
       else()
-          message(FATAL_ERROR "Qt5 was NOT found ...")
+          ecbuild_critical("Qt5 was NOT found ...")
       endif()
     else()
     find_package(Qt4 4.4.3 REQUIRED QtCore QtGui QtXml )
@@ -195,7 +204,7 @@
 # find extra packages
 
 set( CMAKE_THREAD_PREFER_PTHREAD 1 )
-find_package( Threads ) 
+find_package( Threads )
 
 # set(Boost_USE_STATIC_LIBS        ON)
 # set(Boost_NO_SYSTEM_PATHS        ON)
@@ -211,13 +220,13 @@
 
 set( MAGICS_TPLS grib_api spot EXPAT NetCDF PNG Proj4 libemos )
 
-set( MAGICS_INCLUDE_DIRS 
-     ${CMAKE_CURRENT_SOURCE_DIR}/src 
-     ${CMAKE_BINARY_SOURCE_DIR}/src 
-     ${CMAKE_CURRENT_SOURCE_DIR}/src/common 
-     ${CMAKE_CURRENT_BINARY_DIR}/src/params 
-     ${CMAKE_CURRENT_BINARY_DIR}/src 
-     ${CMAKE_CURRENT_SOURCE_DIR}/src/common  
+set( MAGICS_INCLUDE_DIRS
+     ${CMAKE_CURRENT_SOURCE_DIR}/src
+     ${CMAKE_BINARY_SOURCE_DIR}/src
+     ${CMAKE_CURRENT_SOURCE_DIR}/src/common
+     ${CMAKE_CURRENT_BINARY_DIR}/src/params
+     ${CMAKE_CURRENT_BINARY_DIR}/src
+     ${CMAKE_CURRENT_SOURCE_DIR}/src/common
      ${CMAKE_CURRENT_SOURCE_DIR}/src/basic
      ${CMAKE_CURRENT_SOURCE_DIR}/src/web
      ${CMAKE_CURRENT_SOURCE_DIR}/src/visualisers
@@ -299,7 +308,7 @@
 # shared files
 add_subdirectory( share )
 
-# python interface 
+# python interface
 add_subdirectory( python )
 
 # apps directory
@@ -314,18 +323,18 @@
 # Directories not need in the distribution tar ball!
 ecbuild_add_resources( TARGET old_src DONT_PACK_DIRS src/MvObs src/libTable src/xml src/terralib/functions)
 ecbuild_add_resources( TARGET bamboo DONT_PACK_DIRS bamboo)
-ecbuild_add_resources( TARGET old_ressources 
-		DONT_PACK_DIRS tools/versioncmp 
-		tools/regression 
+ecbuild_add_resources( TARGET old_ressources
+		DONT_PACK_DIRS tools/versioncmp
+		tools/regression
 		regression
 		docs
 		toolsjs
 		test/old
-		tools/xml 
+		tools/xml
 		tools/use_scripts
 		tools/versioncmp_folders)
 
-ecbuild_add_resources( TARGET internal 
+ecbuild_add_resources( TARGET internal
 		DONT_PACK configure.lxab
 		configure.local
 		configure.ecgb

=== python/CMakeLists.txt ===
if( HAVE_PYTHON )

  configure_file( setup.py.in setup.py )
  configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/../src/common/magics_api.h magics_api.h COPYONLY )
  configure_file( numpy.i numpy.i COPYONLY )
  configure_file( Magics_interface.cc Magics_interface.cc COPYONLY )
  configure_file( Magics.i.in Magics/Magics.i )

  # Copy python modules to build area
  # configure_file ensures the copy is triggered if the file changes
  configure_file( Magics/__init__.py Magics/__init__.py COPYONLY )
  configure_file( Magics/macro.py Magics/macro.py COPYONLY )
  configure_file( Magics/toolbox.py Magics/toolbox.py COPYONLY )
  configure_file( Magics/metgram.py Magics/metgram.py COPYONLY )

  set( _magics_swig "_Magics${CMAKE_SHARED_LIBRARY_SUFFIX}" )
  # Build the extension module for use in build tree with RPATH pointing to the build tree
  add_custom_command( OUTPUT ${_magics_swig}
    COMMAND ${PYTHON_EXECUTABLE} setup.py build_ext --inplace --rpath ${CMAKE_BINARY_DIR}/lib
    DEPENDS Magics_interface.cc Magics.i.in numpy.i setup.py.in MagPlus )
  add_custom_target(build_swig_wrapper ALL DEPENDS ${_magics_swig})

  # Build the extension module for use in install tree with RPATH pointing to install tree
  install(CODE "execute_process(COMMAND ${PYTHON_EXECUTABLE} setup.py build_ext --rpath ${CMAKE_INSTALL_PREFIX}/${INSTALL_LIB_DIR} WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})")
  # Call distutils for installation
  install(CODE "execute_process(COMMAND ${PYTHON_EXECUTABLE} setup.py install --root \$ENV{DESTDIR}/ --prefix ${CMAKE_INSTALL_PREFIX} WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})")

endif()

=== cmake/contrib/GreatCMakeCookOff/tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3 FATAL_ERROR)
project(COOKOFF_TEST)

enable_testing()

include(${PROJECT_SOURCE_DIR}/../TestCMake.cmake)

cmake_test(checkisnan SOURCE)
cmake_test(checkcpp11flags)
cmake_test(addgtest NOEXEC SOURCE --test-command ${CMAKE_MAKE_PROGRAM} test)

add_subdirectory(cpp11)

=== debian/changelog ===
magics++ (2.34.0-1) unstable; urgency=medium

  * New upstream release
  * Add watch file

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 02 Jul 2017 08:59:31 +0100

magics++ (2.33.0-1) unstable; urgency=medium

  * New upstream release
  * Patch needed for xml2mv.py type error
  * Standards-Version: 4.0.0., no changes required

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 20 Jun 2017 10:24:32 +0100

magics++ (2.32.0-3) experimental; urgency=medium

  * Depend on python3-dev, not -all-dev. Closes: #863003

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 18 May 2017 03:02:39 +0100

magics++ (2.32.0-2) experimental; urgency=medium

  * Fixes to python3; Closes: #858949
  * Silence HAVE_GEOTIFF dup warnings.
  * Delete ./src/boost in rules to ensure boost pkg is used
  * Allow build with libboost-dev | libboost1.63-dev for testing

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 25 Apr 2017 11:44:09 +0100

magics++ (2.32.0-1) experimental; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 24 Mar 2017 16:04:05 +0000

magics++ (2.31.0-1) experimental; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 21 Feb 2017 10:54:08 +0000

=== debian/control ===
--- 
+++ 
@@ -4,8 +4,8 @@
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
 Build-Depends: debhelper  (>= 10) , dh-buildinfo, gfortran, cmake, chrpath,
  dh-python,  swig,
- python-all-dev, python-numpy, 
- python3-all-dev, python3-numpy,
+ python-dev, python-numpy, 
+ python3-dev, python3-numpy,
  libhdf5-serial-dev | libhdf5-dev, libnetcdf-dev, libnetcdf-cxx-legacy-dev,
  libgl1-mesa-dev, libgd-dev, 
  libemos-dev (>=  2:4.3.9), libgeotiff-dev,
@@ -16,9 +16,9 @@
  libterralib-dev, 
  libcairo2-dev, libpango1.0-dev,
  ttf-dejavu-core, libxml-parser-perl, 
- ghostscript, zlib1g-dev, libboost-dev, libproj-dev, 
+ ghostscript, zlib1g-dev, libboost-dev | libboost1.63-dev, libproj-dev, 
  qtbase5-dev-tools, qtbase5-dev, qt5-qmake
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Homepage: https://software.ecmwf.int/wiki/display/MAGP/Magics
 Vcs-Git: git://anonscm.debian.org/debian-science/packages/magics.git

=== debian/rules ===
--- 
+++ 
@@ -12,6 +12,8 @@
 export LC_ALL
 
 export QT_SELECT=5
+
+export CXX=g++-6
 
 LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)
 AUTOGENERATED:= libmagplus3v5.links libmagics++-dev.links libmagplus3v5.install
@@ -86,7 +88,7 @@
 	rm -f bin/magjsonx  bin/magmlx  bin/metgramx
 	find . -type l -delete
 	rm -f src/params/*.h src/decoders/*Attributes.h
-	rm -rf share/magics/ttf src/terralib debian/build
+	rm -rf share/magics/ttf src/terralib debian/build src/boost
 	rm -f $(patsubst %, debian/%, ${AUTOGENERATED})
 
 override_dh_auto_configure:

=== debian/watch ===
version=3
https://software.ecmwf.int/wiki/display/MAGP/Releases /wiki/download/attachments/3473464/Magics\-(.+)\-Source\.tar\.gz\?api=v2
